-- AUTOCAD COMMAND EMULATION ************************************************ 
global _pline
global _mline
global _copy
global _move
global _scale
global _rotate
global _mirror
global _dist
global r_command_rollout
global _offset
global _extend
global _array
global _circle
global acadcom

-- INCLUDE FILES ************************************************************
filein "functionlibrary.ms"
filein "pline.ms"
filein "mline.ms"
filein "copy.ms"
filein "move.ms"
filein "scale.ms"
filein "rotate.ms"
filein "mirror2d.ms"
filein "dist.ms"
filein "acadtoolbar1.ms"
filein "offsets.ms"
filein "trimext.ms"
filein "array.ms"
filein "circle.ms"

-- UTILITY PANEL DEFINITION *************************************************
utility acadcom "AutoCAD Shortcuts"
(
	
	-- VARIABLE DECLARATIONS
	local btn_size = 25
	local acad_float
	
	-- FUNCTION DEFINITIONS
	fn acad_tb =
	(
		if (classof acad_float == RolloutFloater) do 
			closeRolloutFloater acad_float
		acad_float = newrolloutfloater "AutoCAD Shortcuts" 390 100 435 80		
		addrollout r_command_rollout acad_float
	)
	-- USER INTERFACE ITEMS *****************************************************
	
	-- FLOAT IT BUTTON 
	checkbutton btn_float_acad "Float Toolbar" tooltip:"Create floating toolbar"
	
	-- OBJECT CREATION GROUP
	group "Object Creation" ( 
		
		-- Pline 	
		button btn_pline\
			images:#("draw1.bmp",undefined,16,4,4,4,4) \
			tooltip:"Pline" width:btn_size height:btn_size \
			across:4
	
		-- Mline 	
		button btn_mline\
			images:#("draw1.bmp",undefined,16,3,3,3,3) \
				tooltip:"Mline" width:btn_size height:btn_size
		
		-- Circle
		button btn_circle\
			images:#("draw1.bmp",undefined,16,8,8,8,8) \
			tooltip:"Circle" width:btn_size height:btn_size
		
		-- Array
		button btn_array\
			images:#("modify1.bmp",undefined,16,5,5,5,5) \
			tooltip:"Array" width:btn_size height:btn_size
			
	)
	
	-- OBJECT EDIT GROUP
	group "Object Edit"  (
		-- Copy 
		button btn_copy "Copy" \
			images:#("modify1.bmp",undefined,16,2,2,2,2) \
			tooltip:"Copy Object" width:btn_size height:btn_size \
			across:5
			
		-- Move 
		button btn_move "Move" \
			images:#("Modify1.bmp",undefined,16,6,6,6,6) \
			tooltip:"Move" width:btn_size height:btn_size
			
		-- Offset 	
		button btn_offset "Offset" \
			images:#("Modify1.bmp",undefined,16,4,4,4,4) \
			tooltip:"Offset" width:btn_size height:btn_size	
			
		-- Mirror 	
		button btn_mirror "Mirror" \
			images:#("Modify1.bmp",undefined,16,3,3,3,3) \
			tooltip:"Mirror" width:btn_size height:btn_size
		
		-- Rotate 	
		button btn_rotate \
			images:#("Modify1.bmp",undefined,16,7,7,7,7) \
			tooltip:"Rotate" width:btn_size height:btn_size 
		
		-- Scale 	
		button btn_scale \
			images:#("Modify1.bmp",undefined,16,8,8,8,8) \
			tooltip:"Scale" width:btn_size height:btn_size across:4
	
		-- Trim 	
		button btn_trim  \
			images:#("Modify1.bmp",undefined,16,11,11,11,11) \
			tooltip:"Trim" width:btn_size height:btn_size  
			
		-- Extend 	
		button btn_extend  \
			images:#("Modify1.bmp",undefined,16,12,12,12,12) \
			tooltip:"Extend" width:btn_size height:btn_size 
			
		-- Distance	
		button btn_distance \
			images:#("inquiry1.bmp",undefined,3,1,1,1,1) \
			tooltip:"Distance" width:btn_size height:btn_size 
			
	)
	
	
	-- EVENT HANDLERS **************************************************
	on btn_float_acad changed state do 
	(
		if state then (
			try (acad_tb())
			catch(clearlistener())
		) else (
			try (closeRolloutFloater acad_float)
			catch(clearlistener())
		)
	)
	
	on btn_copy pressed do 
	(
		try (_copy())
		catch(clearlistener() ; format "OK\n")
	)
	
	on btn_move pressed do 
	(
		try (_move())
		catch(clearlistener() ; format "OK\n")
	)

	on btn_offset pressed do 
	(
		try(_offset())
		catch(clearlistener() ; format "OK\n" )
	)

	on btn_mirror pressed do 
	(
		try (_mirror())
		catch(clearlistener() ; format "OK\n")
	)

	on btn_rotate pressed do
	(
		try (_rotate())
		catch(clearlistener() ; format "OK\n")
	)
 
	on btn_scale pressed do 
	(
		try (_scale())
		catch(clearlistener() ; format "OK\n")
	)

	on btn_trim pressed do 
	(
		try(_trim())
		catch(clearlistener() ; format "OK\n" )
	)

	on btn_extend pressed do
	(
		try(_extend())
		catch(clearlistener() ; format "OK\n" )
	)
		
	on btn_pline pressed do	
	(
		try (_pline())
		catch(clearlistener() ; format "OK\n")
	)
	
	on btn_mline pressed do 
	(
		try (_mline())
		catch(clearlistener() ; format "OK\n")
	)

	on btn_array pressed do 
	(
		try (_array())
		catch(clearlistener() ; format "OK\n")
	)

	on btn_circle pressed do 
	(
		try (_circle())
		catch(clearlistener() ; format "OK\n")
	)

	on btn_distance pressed do 
	(
		try (_dist())
		catch(clearlistener() ; format "OK\n")
	)

	on acadcom open do 
	(
		try (
			acad_tb()
			btn_float_acad.checked = true
		)catch(clearlistener() ; format "OK\n")
	)
	
	on acadcom close do
	(
		closeRolloutFloater acad_float
	)
)	


