-- AUTOCAD COPY COMMAND EMULATION
fn _copy = 
(
	-- DECLARE VARIABLES
	local Item,Disp,pt1,pt2,obj
	local OrigGroup,CGroup,PArray
	local i,Pt
	local R,RtnCode
	local proceed
	

	-- MOUSE MOVE HANDLER
	fn Mhandler pt2 =
	(
		local i = 1
		local disp = (_copy.pt2 - _copy.pt1)
		for obj in _copy.CGroup do
		(
			local Pt = _copy.PArray[i]
			obj.pos = Pt + disp
			i += 1
		)
	)
	
		
	-- DESELECT ANY OBJECT(S) CURRENTLY SELECTED
	max select none
	
	-- DISABLE ESCAPE KEY AND CLEAR LISTENER
	EscapeEnable = false
	clearListener()
	
	-- LOOP TO ADD ITEMS TO SELECTION
	while true do
	(
		Item = pickObject prompt:"Select Objects:" count:1
		
		if Item == #Escape do
		(
			max select none
			EscapeEnable = true
			redrawviews()
			setListenerSel #(-1,-1)
			return (format "*Cancel*\nOK\n")
		)
		
		if Item == undefined do exit
		
		selectmore Item
		redrawviews()
		format "\n"
	)
	format "\n"

	
	-- IF SELECTION SET IS EMPTY RETURN
	if selection.count == 0 do
	(
		max select none
		setListenerSel #(-1,-1)
		EscapeEnable = true
		return (format "*Cancel*\nOK\n")
	)

	-- MAKE ARRAY BASED COPY OF SELECTION
	CGroup = #()
	OrigGroup = selection as array
	for obj in OrigGroup do
	(
		NewObj = copy obj
		NewObj.transform = obj.transform
		append CGroup NewObj
	)
	
	-- SAVE ORIGINAL OBJECT POSTIONS
	PArray = #()
	for obj in CGroup do append PArray obj.pos

	-- PROMPT FOR BASE POINT OF DISPLACEMENT		
	pt1 = pickpoint prompt:"Base point or displacement:" snap:#3D
	
	if (ClassOf pt1 != Point3) do
	(
		delete CGroup
		max select none
		EscapeEnable = true
		setListenerSel #(-1,-1)
		return (format "*Cancel*\nOK\n")
	)
	format "\n"
	
	-- PROMPT FOR SECOND POINT OF DISPLACEMENT
	pt2 = pickpoint prompt:"Second point of displacement:" rubberband:pt1 mouseMoveCallBack:MHandler snap:#3D
		
	if (pt2 == "" or pt2 == #rightClick) 
	then Disp = pt1
	else if (ClassOf pt2 == Point3) then (Disp = pt2 - pt1)
	else  
	(
		delete CGroup
		max select none
		EscapeEnable = true
		setListenerSel #(-1,-1)
		return (format "*Cancel*\nOK\n")
	)

	-- COPY OBJECTS
	i = 1
	for obj in CGroup do
	(
		Pt = PArray[i]
		obj.pos = Pt + Disp
		i += 1
	)
				
	-- DESELECT OBJECTS AND REDRAW SCREEN
	max select none
	max views redraw
	
	-- RE-ENABLE ESCAPE KEY
	EscapeEnable = true
	setListenerSel #(-1,-1)
	format "\nOK\n"
)
