-- AUTOCAD MOVE COMMAND EMULATION
fn _move = 
(
	-- DECLARE VARIABLES
	local Item,Disp,pt1,pt2
	local MGroup,PArray,i,Pt
	local R,RtnCode,proceed

		
	-- MOUSE MOVE HANDLER
	fn Mhandler pt2 =
	(
		local i = 1
		for obj in _move.MGroup do
		(
			local Pt = _move.PArray[i]
			obj.pos = Pt + (_move.pt2 - _move.pt1)
			i += 1
		)
	)
	
	-- DESELECT ANY OBJECT(S) CURRENTLY SELECTED
	max select none
	
	-- DISABLE ESCAPE KEY AND CLEAR LISTENER
	EscapeEnable = false
	clearListener()

	-- LOOP TO ADD ITEMS TO SELECTION
	while true do
	(
		Item = pickObject prompt:"Select Objects:" count:1
		
		if Item == #Escape do
		(
			max select none
			EscapeEnable = true
			redrawviews()
			setListenerSel #(-1,-1)
			return (format "*Cancel*\nOK\n")
		)
		
		if Item == undefined do exit
		
		selectmore Item
		redrawviews()
		format "\n"
	)
	format "\n"
	
	-- IF SELECTION SET IS EMPTY RETURN
	if selection.count == 0 do
	(
		max select none
		setListenerSel #(-1,-1)
		EscapeEnable = true
		return (format "*Cancel*\nOK\n")
	)
	
	-- CONVERT SELECTION TO ARRAY
	MGroup = selection as array
	
	-- SAVE ORIGINAL OBJECT POSTIONS
	PArray = #()
	for obj in MGroup do append PArray obj.pos
		
	-- PROMPT FOR BASE POINT OF DISPLACEMENT		
	pt1 = pickpoint prompt:"Base point or displacement:" snap:#3D
	 
	if (ClassOf pt1 != Point3) do
	(
		max select none
		EscapeEnable = true
		setListenerSel #(-1,-1)
		return (format "*Cancel*\nOK\n")
	)
	format "\n"
	
	-- PROMPT FOR SECOND POINT OF DISPLACEMENT
	pt2 = pickpoint prompt:"Second point of displacement:" rubberband:pt1 mouseMoveCallBack:MHandler snap:#3D
	if (pt2 == "" or pt2 == #rightClick) 
	then Disp = pt1
	else if (ClassOf pt2 == Point3) then (Disp = pt2 - pt1)
	else  
	(
		-- PUT THE OBJECTS BACK INTO THEIR ORIGINAL POSITIONS
		i = 1
		for obj in MGroup do
		(
			Pt = PArray[i]
			obj.pos = Pt
			i += 1
		)

		max select none
		EscapeEnable = true
		setListenerSel #(-1,-1)
		return (format "*Cancel*\nOK\n")
	)
	format "\n"

	-- MOVE OBJECTS
	i = 1
	for obj in MGroup do
	(
		Pt = PArray[i]
		obj.pos = Pt + Disp
		i += 1
	)

	-- DESELECT OBJECTS AND REDRAW SCREEN
	max select none
	max views redraw
	EscapeEnable = true
	SetListenerSel #(-1,-1)
	format "OK\n"
)
