-- Offset function

fn _offset = 
(
	local mode, distance, obj, pt1
	local msg1 = "Offset distance or Through <Through>:\n"
	local msg2 = "Second point:\n"
	local msg3 = "Requires numeric distance, two points, or option keyword.\n"
	
	
	-- SYSTEM SETTINGS
	clearListener()
	EscapeEnable = false
	
	-- DESELECT CURRENT SELECTION
	max select none
	
	do 
	(
		mode = pickOffsetDistance prompt:msg1 pt2Prompt:msg2 errPrompt:msg3 keyword:"Through"
		
		-- IF USER PRESSES ESCAPE
		if (mode == #Escape or mode==#rightclick) do
		(
			setListenerSel #(-1,-1)
			return (format "*Cancel*\nOK\n")
		)
		
		-- ERROR CHECK, THIS SHOULD NEVER BE TRUE
		if ( mode != true and superClassOf mode != Number ) do
		(
			setListenerSel #(-1,-1)
			return (format "*Cancel*\nOK\n")
		)

 		-- IF A NUMBER LESS THAN OR EQUAL TO ZERO IS ENTERED
		if (mode != true and mode <= 0 ) do
		(
			setListenerSel #(-1,-1)
			format "Value must be positive and nonzero.\n"
		)
			
	) while (mode != true and mode <= 0)
	
	while true do 
	(
		distance = mode
		
		-- SELECT OBJECT TO BE OFFSET
		while true do
		(	
			obj = pickObject prompt:"Select object to offset:" count:1 select:true
		
			if (obj==undefined or obj==#Escape) do
	 		(
				EscapeEnable = true
				setListenerSel #(-1,-1)
				return (format "*Cancel*\nOK\n")
			)
			
			if superclassof obj==shape 
			then exit
			else
			(
				format "Shape object required...\n"
				max select none
			)
		)	
		format "\n"
		
		if distance == true 
		then 
		(	-- Through case
			pt1 = pickPoint prompt:"Through point:"
				
			if (ClassOf pt1 != Point3) do
			(
				EscapeEnable=true
				max select none
				setListenerSel #(-1,-1)
				return (format "*Cancel*\nOK\n")
			)
			format "\n"
				
			distance = measureOffset obj pt1
		)
		else 
		(	-- Numeric case	
			pt1 = pickPoint prompt:"Side to offset?"
				
			if (ClassOf pt1 != Point3) do
			(
				EscapeEnable=true
				max select none
				setListenerSel #(-1,-1)
				return (format "*Cancel*\nOK\n")
			)
			format "\n"
			
			if (measureOffset obj pt1) < 0 then distance = -distance
		)
		
		-- APPLY THE OFFSET
		try (applyOffset obj (distance + 0.0) )
		catch
		(
			EscapeEnable = true
			max select none
			setListenerSel #(-1,-1)
			return (format "*Error*\nOK\n")
		)
	)
	
	EscapeEnable = true
	max select none
	setListenerSel #(-1,-1)
	format "OK\n"
)
