-- SCALE COMMAND EMULATION
fn _scale =
(
	local ScaleItems
	local BasePt
	local sf
	
	-- TURN OFF ESCAPE KEY AND CLEAR LISTENER
	EscapeEnable = false
	clearlistener()
	
	-- DESELECT ANY OBJECT(S) CURRENTLY SELECTED
	max select none
	
	-- PROMPT FOR OBJECTS TO SCALE
	ScaleItems = pickObject prompt:"Select Objects:" count:#multiple select:true
	
	if (ClassOf ScaleItems != array or ScaleItems.count==0) do
	(
		EscapeEnable = true
		max select none
		SetListenerSel #(-1,-1)
		return (format "*Cancel*\nOK\n")
	)
	format "\n"
	
	-- PROMPT FOR SCALE BASE POINT		
	BasePt = pickpoint prompt:"Base point:" snap:#3D
	
	if (ClassOf BasePt != Point3) do
	(
		EscapeEnable = true
		max select none
		setListenerSel #(-1,-1)
		return (format "*Cancel*\nOK\n")
	)
	format "\n"

	-- PROMPT FOR SCALE FACTOR
	if (sf = getreal prompt:"Scale factor:" minval:0 maxval:1E4 default:2) == #Escape do
	(
		EscapeEnable = true
		max select none
		setListenerSel #(-1,-1)
		return (format "*Cancel*\nOK\n")
	)
	
	-- SCALE OBJECTS IN SELECTION SET
	about BasePt scale ScaleItems [sf,sf,sf]  
	
		
	-- RESET SYSTEM PARAMETERS
	EscapeEnable = true
	max select none
	max views redraw
	setListenerSel #(-1,-1)
	format "OK\n"
	)
